var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { File } from "@ionic-native/file";
import { IonicUnzipOptions } from "./ionicUnzipOption";
var IonicUnzip = /** @class */ (function () {
    function IonicUnzip(fs) {
        this.fs = fs;
        this.options = new IonicUnzipOptions();
    }
    /**
     * Unzip a file
     * @param {IonicUnzipOptions} options
     * @returns {Promise<any>}
     */
    IonicUnzip.prototype.unzip = function (userOptions) {
        var _this = this;
        Object.assign(this.options, userOptions);
        return this.fs.createDir(this.dataDir(), this.options.targetDir, this.options.overwrite).then(function () {
            _this.fs.readAsArrayBuffer(_this.dataDir(), _this.options.fileName).then(function (ab) {
                var new_zip = new JSZip();
                new_zip.loadAsync(ab)
                    .then(function (zip) {
                    Object.keys(zip.files).forEach(function (filename) {
                        zip.files[filename].async('arraybuffer').then(function (fileData) {
                            _this.fs.createFile(_this.dataDir(), filename, _this.options.overwrite).then(function () {
                                _this.fs.writeFile(_this.dataDir(), filename, fileData, { replace: _this.options.overwrite }).then(function (fileInfo) {
                                    if (_this.options.verbose) {
                                        console.log('File written', fileInfo);
                                    }
                                }).catch(function (e) {
                                    console.error("Could not write file" + filename);
                                    console.error(e);
                                });
                            }).catch(function (e) {
                                console.error("Could not create file " + filename);
                                console.error(e);
                            });
                        });
                    });
                }).catch(function (e) {
                    console.error("Error with zip file");
                    throw new Error(e.message);
                });
            });
        });
    };
    /**
     * @returns {string}
     */
    IonicUnzip.prototype.dataDir = function () {
        return this.options.dataDir || this.fs.dataDirectory;
    };
    IonicUnzip = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [File])
    ], IonicUnzip);
    return IonicUnzip;
}());
export { IonicUnzip };
//# sourceMappingURL=IonicUnzip.js.map